/* Copyright 2013 Daniel Hanrahan. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE DANIEL HANRAHAN "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL DANIEL HANRAHAN BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

// Auto-generated by struct2cpp, Mon Jan 21 01:28:46 2013

#ifndef BUILDING_HPP
#define BUILDING_HPP

#include "BofWriter.hpp"
#include <ostream>
#include <vector>
#include "BofReader.hpp"

class Building {
public:
#ifdef DEBUG
	friend std::ostream& operator<< (std::ostream&, const Building&);
#endif
	void read (BofReader& r);
	void write (BofWriter& w) const;


	std::string name() const { return m_Name; }
	std::string namePlural() const { return m_NamePlural; }
	unsigned short id() const { return m_Id; }
	unsigned short upgradeFor() const { return m_UpgradeFor; }
	int unknown1() const { return m_Unknown1; }
	std::string picture() const { return m_Picture; }
	unsigned short unknown2 (size_t i) const { return m_Unknown2[i]; }
	unsigned short techField() const { return m_TechField; }
	unsigned short techLevel() const { return m_TechLevel; }
	bool excludeMajors (size_t i) const { return m_ExcludeMajors[i]; }
	bool raceReq (size_t i) const { return m_RaceReq[i]; }
	unsigned short politicReq() const { return m_PoliticReq; }
	unsigned short systemReq() const { return m_SystemReq; }
	unsigned short bonusType() const { return m_BonusType; }
	unsigned short restriction() const { return m_Restriction; }
	unsigned short group() const { return m_Group; }
	unsigned short category() const { return m_Category; }
	unsigned short buildCost() const { return m_BuildCost; }
	short energyCost() const { return m_EnergyCost; }
	short popCost() const { return m_PopCost; }
	short moraleBonus() const { return m_MoraleBonus; }
	short bonus (size_t i) const { return m_Bonus[i]; }
	short bonusToUnrestThreshold (size_t i) const { return m_BonusToUnrestThreshold[i]; }
	int descAddress() const { return m_DescAddress; }

	void name (const std::string& Val) { m_Name = Val; }
	void namePlural (const std::string& Val) { m_NamePlural = Val; }
	void id (unsigned short Val) { m_Id = Val; }
	void upgradeFor (unsigned short Val) { m_UpgradeFor = Val; }
	void unknown1 (int Val) { m_Unknown1 = Val; }
	void picture (const std::string& Val) { m_Picture = Val; }
	void unknown2 (size_t i, unsigned short Val) { m_Unknown2[i] = Val; }
	void techField (unsigned short Val) { m_TechField = Val; }
	void techLevel (unsigned short Val) { m_TechLevel = Val; }
	void excludeMajors (size_t i, const bool Val) { m_ExcludeMajors[i] = Val; }
	void raceReq (size_t i, const bool Val) { m_RaceReq[i] = Val; }
	void politicReq (unsigned short Val) { m_PoliticReq = Val; }
	void systemReq (unsigned short Val) { m_SystemReq = Val; }
	void bonusType (unsigned short Val) { m_BonusType = Val; }
	void restriction (unsigned short Val) { m_Restriction = Val; }
	void group (unsigned short Val) { m_Group = Val; }
	void category (unsigned short Val) { m_Category = Val; }
	void buildCost (unsigned short Val) { m_BuildCost = Val; }
	void energyCost (short Val) { m_EnergyCost = Val; }
	void popCost (short Val) { m_PopCost = Val; }
	void moraleBonus (short Val) { m_MoraleBonus = Val; }
	void bonus (size_t i, short Val) { m_Bonus[i] = Val; }
	void bonusToUnrestThreshold (size_t i, short Val) { m_BonusToUnrestThreshold[i] = Val; }
	void descAddress (int Val) { m_DescAddress = Val; }

private:
	std::string m_Name;
	std::string m_NamePlural;
	unsigned short m_Id;
	unsigned short m_UpgradeFor;
	int m_Unknown1;
	std::string m_Picture;
	unsigned short m_Unknown2[5];
	unsigned short m_TechField;
	unsigned short m_TechLevel;
	std::vector<bool> m_ExcludeMajors;
	std::vector<bool> m_RaceReq;
	unsigned short m_PoliticReq;
	unsigned short m_SystemReq;
	unsigned short m_BonusType;
	unsigned short m_Restriction;
	unsigned short m_Group;
	unsigned short m_Category;
	unsigned short m_BuildCost;
	short m_EnergyCost;
	short m_PopCost;
	short m_MoraleBonus;
	short m_Bonus[6];
	short m_BonusToUnrestThreshold[6];
	int m_DescAddress;
};

#endif

