/* Copyright 2013 Daniel Hanrahan. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE DANIEL HANRAHAN "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL DANIEL HANRAHAN BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

// Auto-generated by struct2cpp, Mon Jan 21 01:28:46 2013

#include "Building.hpp"
#include "PrintVector.hpp"

void Building::read (BofReader& r)
{
	m_Name = r.read_string(40);
	m_NamePlural = r.read_string(40);
	m_Id = r.read_word();
	m_UpgradeFor = r.read_word();
	m_Unknown1 = r.read_int();
	m_Picture = r.read_string(8);
	for (size_t i = 0; i < 5; i++) {
		m_Unknown2[i] = r.read_byte();
	}
	m_TechField = r.read_byte();
	m_TechLevel = r.read_byte();
	m_ExcludeMajors = r.read_bits8();
	m_RaceReq = r.read_bits64();
	m_PoliticReq = r.read_byte();
	m_SystemReq = r.read_byte();
	m_BonusType = r.read_byte();
	m_Restriction = r.read_byte();
	m_Group = r.read_byte();
	m_Category = r.read_byte();
	r.skip(2);
	m_BuildCost = r.read_word();
	r.skip(2);
	m_EnergyCost = r.read_short();
	r.skip(2);
	m_PopCost = r.read_short();
	m_MoraleBonus = r.read_short();
	r.skip(2);
	for (size_t i = 0; i < 6; i++) {
		m_Bonus[i] = r.read_short();
	}
	for (size_t i = 0; i < 6; i++) {
		m_BonusToUnrestThreshold[i] = r.read_short();
	}
	r.skip(14);
	m_DescAddress = r.read_int();
}

void Building::write (BofWriter& w) const
{
	w.write_string(m_Name, 40);
	w.write_string(m_NamePlural, 40);
	w.write_word(m_Id);
	w.write_word(m_UpgradeFor);
	w.write_int(m_Unknown1);
	w.write_string(m_Picture, 8);
	for (size_t i = 0; i < 5; i++) {
		w.write_byte(m_Unknown2[i]);
	}
	w.write_byte(m_TechField);
	w.write_byte(m_TechLevel);
	w.write_bits8(m_ExcludeMajors);
	w.write_bits64(m_RaceReq);
	w.write_byte(m_PoliticReq);
	w.write_byte(m_SystemReq);
	w.write_byte(m_BonusType);
	w.write_byte(m_Restriction);
	w.write_byte(m_Group);
	w.write_byte(m_Category);
	w.pad(2);
	w.write_word(m_BuildCost);
	w.pad(2);
	w.write_short(m_EnergyCost);
	w.pad(2);
	w.write_short(m_PopCost);
	w.write_short(m_MoraleBonus);
	w.pad(2);
	for (size_t i = 0; i < 6; i++) {
		w.write_short(m_Bonus[i]);
	}
	for (size_t i = 0; i < 6; i++) {
		w.write_short(m_BonusToUnrestThreshold[i]);
	}
	w.pad(14);
	w.write_int(m_DescAddress);
}

#ifdef DEBUG
std::ostream& operator<< (std::ostream& o, const Building& c)
{
	o << "Contents of Building:" << std::endl;
	o << "name = " << c.m_Name << std::endl;
	o << "namePlural = " << c.m_NamePlural << std::endl;
	o << "id = " << c.m_Id << std::endl;
	o << "upgradeFor = " << c.m_UpgradeFor << std::endl;
//	o << "unknown1 = " << c.m_Unknown1 << std::endl;
	o << "picture = " << c.m_Picture << std::endl;
/*	o << "unknown2 = { ";
	for (size_t i = 0; i < 5; ++i) {
		o << c.m_Unknown2[i] << ' ';
	}
	o << '}' << std::endl;*/
	o << "techField = " << c.m_TechField << std::endl;
	o << "techLevel = " << c.m_TechLevel << std::endl;
	o << "excludeMajors = " << c.m_ExcludeMajors << std::endl;
	o << "raceReq = " << c.m_RaceReq << std::endl;
	o << "politicReq = " << c.m_PoliticReq << std::endl;
	o << "systemReq = " << c.m_SystemReq << std::endl;
	o << "bonusType = " << c.m_BonusType << std::endl;
	o << "restriction = " << c.m_Restriction << std::endl;
	o << "group = " << c.m_Group << std::endl;
	o << "category = " << c.m_Category << std::endl;
	o << "buildCost = " << c.m_BuildCost << std::endl;
	o << "energyCost = " << c.m_EnergyCost << std::endl;
	o << "popCost = " << c.m_PopCost << std::endl;
	o << "moraleBonus = " << c.m_MoraleBonus << std::endl;
	o << "bonus = { ";
	for (size_t i = 0; i < 6; ++i) {
		o << c.m_Bonus[i] << ' ';
	}
	o << '}' << std::endl;
	o << "bonusToUnrestThreshold = { ";
	for (size_t i = 0; i < 6; ++i) {
		o << c.m_BonusToUnrestThreshold[i] << ' ';
	}
	o << '}' << std::endl;
	o << "descAddress = " << c.m_DescAddress << std::endl;
	return o;
}
#endif

