/* Copyright 2013 Daniel Hanrahan. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE DANIEL HANRAHAN "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL DANIEL HANRAHAN BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


// This is code from Edifice::read

	// Add a more advanced farm!
	{
	Building& bld = getBuildingById (152);
	Building newBld = bld;
	newBld.id( m_Buildings.size() );
	newBld.upgradeFor( bld.id() );
	newBld.name( "Type 10 Automated Farm" );
	newBld.namePlural( "Type 10 Automated Farms" );
	newBld.techLevel( bld.techLevel() + 1 );
	newBld.buildCost( bld.buildCost() * 1.2 );
	printf ("adding %u, up=%u\n", newBld.id(), newBld.upgradeFor());
	m_Buildings.push_back( newBld );
	}
	{
	Building& bld = getBuildingById (152);
	Building newBld = bld;
	newBld.id( m_Buildings.size() );
	newBld.upgradeFor( m_Buildings.size() - 1 );
	newBld.name( "Type 11 Automated Farm" );
	newBld.namePlural( "Type 11 Automated Farms" );
	newBld.techLevel( bld.techLevel() + 2 );
	newBld.buildCost( bld.buildCost() * 1.4 );
	printf ("adding %u, up=%u\n", newBld.id(), newBld.upgradeFor());
	m_Buildings.push_back( newBld );
	}
	// Next step is Bunker Network!
	{
	Building& bld = getBuildingById (2);
	bld.group( 31 );
//	bld.bonusType( 0 );
	Building newBld = bld;
	newBld.id( m_Buildings.size() );
	newBld.upgradeFor( 2 );
	newBld.name( "Deep Bunker Network" );
	newBld.namePlural( "Deep Bunker Networks" );
	newBld.techLevel( 10 );
	newBld.buildCost( bld.buildCost() * 1.2 );
	printf ("adding %u, up=%u\n", newBld.id(), newBld.upgradeFor());
	m_Buildings.push_back( newBld );
	}

	// Now dump the buildings:
/*	for (size_t i = 0; i < NumBuildings; ++i) {
		std::cout << m_Buildings[i] << std::endl;
	}*/

	// Fix the upgrade groups.
//	fixBuildingUpgrades ();


// This is all old code from Edifice.cpp relating to upgrades:

void Edifice::fixBuildingUpgrades () 
{
	std::map<size_t, unsigned char> groups;
	size_t nextGroup = 35;

	// Build id-to-group map.
	for (size_t i = 0; i < m_Buildings.size(); ++i) {
		Building& bld = m_Buildings[i];
		groups[bld.id()] = bld.group();
/*		if (bld.group() >= 30) {
			printf("id=%lu grp=%u\n", bld.id(), bld.group());
		}*/
/*		if (bld.upgradeFor() != 32767) {
			printf("id=%lu grp=%u\n", bld.id(), bld.group());
		}*/
	}

	for (std::map<size_t,unsigned char>::const_iterator 
			it = groups.begin();
			it != groups.end();
			++it)
	{
		printf ("id=%lu grp=%u\n", it->first, it->second);
	}

	// Fix groups.
/*	for (size_t i = 0; i < m_Buildings.size(); ++i) {
		Building& bld = m_Buildings[i];
		// If the building has an upgrade:
		if (bld.upgradeFor() != 32767
		 && bld.group() != 30
		 && (groups[bld.id()] != 
			groups[bld.upgradeFor()] 
			|| groups[bld.upgradeFor()] == 34)
		 )
		{
//			unsigned char group = groups[bld.upgradeFor()];
			unsigned char group = nextGroup;
			// Fix the group.
			bld.group(group);
			groups[bld.id()] = group;
			printf("fixing id=%lu grp=%u\n", bld.id(), group);
			// Set the base group.
			Building& bldBase = getBuildingById 
				(bld.upgradeFor());
			bldBase.group (nextGroup);
			groups[bld.upgradeFor()] = nextGroup;

			nextGroup++;
		}
	}*/

	for (size_t i = 0; i < m_Buildings.size(); ++i) {
		Building& bld = m_Buildings[i];
		// If the building has an upgrade:
		if (bld.upgradeFor() != 32767
		 && (groups[bld.id()] != groups[bld.upgradeFor()] 
			|| groups[bld.upgradeFor()] == 34)
		 )
		{
			printf("fixing id=%lu up=%lu grp=%u newgrp=%u\n", 
					bld.id(), 
					bld.upgradeFor(), 
					bld.group(), 
					nextGroup);
			// Check if its base structure has a group:
			size_t upgradeForId = bld.upgradeFor();
			if (groups[upgradeForId] != 34) {
				// Then set its group to match.
				bld.group (groups[upgradeForId]);
				groups[bld.id()] = groups[upgradeForId];
			} else {
				// Set the base group.
				Building& bldBase = getBuildingById 
					(upgradeForId);
				bldBase.group (nextGroup);
				groups[upgradeForId] = nextGroup;
				// Set this building group.
				bld.group (nextGroup);
				groups[bld.id()] = nextGroup;
				// Increment group counter.
				nextGroup++;
			}
		}
	}
	printf ("[*] %lu upgrade groups defined\n", nextGroup);

}

void Edifice::fixBuildGroupsFromUE() 
{
	// UE screws up the upgrades, so let's restore them here:
	size_t farm_upgrades[5*9] = {
		 98, 144, 190, 236, 282,
		 99, 145, 191, 237, 283,
		100, 146, 192, 238, 284,
		101, 147, 193, 239, 285,
		102, 148, 194, 240, 286,
		103, 149, 195, 241, 287,
		104, 150, 196, 242, 288,
		105, 151, 197, 243, 289,
		106, 152, 198, 244, 290
	};
	size_t factory_upgrades[5*9] = {
		88, 134, 180, 226, 272,
		89, 135, 181, 227, 273,
		90, 136, 182, 228, 274,
		91, 137, 183, 229, 275,
		92, 138, 184, 230, 276,
		93, 139, 185, 231, 277,
		94, 140, 186, 232, 278,
		95, 141, 187, 233, 279,
		96, 142, 188, 234, 280
	};
	size_t energy_upgrades[5*9] = {
		116, 162, 208, 254, 300,
		117, 163, 209, 255, 301,
		118, 164, 210, 256, 302,
		119, 165, 211, 257, 303,
		120, 166, 212, 258, 304,
		121, 167, 213, 259, 305,
		122, 168, 214, 260, 306,
		123, 169, 215, 261, 307,
		124, 170, 216, 262, 308
	};
	size_t research_upgrades[5*9] = {
		125, 171, 217, 263, 309,
		126, 172, 218, 264, 310,
		127, 173, 219, 265, 311,
		128, 174, 220, 266, 312,
		129, 175, 221, 267, 313,
		130, 176, 222, 268, 314,
		131, 177, 223, 269, 315,
		132, 178, 224, 270, 316,
		133, 179, 225, 271, 317
	};
	size_t intel_upgrades[5*9] = {
		107, 153, 199, 245, 291,
		108, 154, 200, 246, 292,
		109, 155, 201, 247, 293,
		110, 156, 202, 248, 294,
		111, 157, 203, 249, 295,
		112, 158, 204, 250, 296,
		113, 159, 205, 251, 297,
		114, 160, 206, 252, 298,
		115, 161, 207, 253, 299
	};
	size_t scanner_upgrades[4] = {
		12, 13, 24, 14
	};
}

